Colt 1.2.0

## cern.colt.list
Class AbstractBooleanList

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.list.AbstractCollection
              cern.colt.list.AbstractList
                  cern.colt.list.AbstractBooleanList

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  BooleanArrayList

public abstract class AbstractBooleanList
extends AbstractList

Abstract base class for resizable lists holding `boolean` elements; abstract. First see the package summary and javadoc tree view to get the broad picture.

See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Method Summary
`void` | `add(boolean element)` Appends the specified element to the end of this list.
`void` | `addAllOfFromTo(AbstractBooleanList other, int from, int to)` Appends the part of the specified list between `from` (inclusive) and `to` (inclusive) to the receiver.
`void` | `beforeInsert(int index, boolean element)` Inserts the specified element before the specified position into the receiver.
`void` | `beforeInsertAllOfFromTo(int index, AbstractBooleanList other, int from, int to)` Inserts the part of the specified list between `otherFrom` (inclusive) and `otherTo` (inclusive) before the specified position into the receiver.
`int` | `binarySearch(boolean key)` Searches the receiver for the specified value using the binary search algorithm.
`int` | `binarySearchFromTo(boolean key, int from, int to)` Searches the receiver for the specified value using the binary search algorithm.
`Object` | `clone()` Returns a deep copy of the receiver.
`boolean` | `contains(boolean elem)` Returns true if the receiver contains the specified element.
`void` | `delete(boolean element)` Deletes the first element from the receiver that is identical to the specified element.
`boolean[]` | `elements()` Returns the elements currently stored, possibly including invalid elements between size and capacity.
`AbstractBooleanList` | `elements(boolean[] elements)` Sets the receiver's elements to be the specified array.
`abstract void` | `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of elements without needing to allocate new internal memory.
`boolean` | `equals(Object otherObj)` Compares the specified Object with the receiver.
`void` | `fillFromToWith(int from, int to, boolean val)` Sets the specified range of elements in the specified array to the specified value.
`boolean` | `forEach(BooleanProcedure procedure)` Applies a procedure to each element of the receiver, if any.
`boolean` | `get(int index)` Returns the element at the specified position in the receiver.
`int` | `indexOf(boolean element)` Returns the index of the first occurrence of the specified element.
`int` | `indexOfFromTo(boolean element, int from, int to)` Returns the index of the first occurrence of the specified element.
`int` | `lastIndexOf(boolean element)` Returns the index of the last occurrence of the specified element.
`int` | `lastIndexOfFromTo(boolean element, int from, int to)` Returns the index of the last occurrence of the specified element.
`AbstractBooleanList` | `partFromTo(int from, int to)` Returns a new list of the part of the receiver between `from`, inclusive, and `to`, inclusive.
`boolean` | `removeAll(AbstractBooleanList other)` Removes from the receiver all elements that are contained in the specified list.
`void` | `removeFromTo(int from, int to)` Removes from the receiver all elements whose index is between `from`, inclusive and `to`, inclusive.
`void` | `replaceFromToWithFrom(int from, int to, AbstractBooleanList other, int otherFrom)` Replaces a number of elements in the receiver with the same number of elements of another list.
`void` | `replaceFromToWithFromTo(int from, int to, AbstractBooleanList other, int otherFrom, int otherTo)` Replaces the part between `from` (inclusive) and `to` (inclusive) with the other list's part between `otherFrom` and `otherTo`.
`void` | `replaceFromWith(int from, Collection other)` Replaces the part of the receiver starting at `from` (inclusive) with all the elements of the specified collection.
`boolean` | `retainAll(AbstractBooleanList other)` Retains (keeps) only the elements in the receiver that are contained in the specified other list.
`void` | `reverse()` Reverses the elements of the receiver.
`void` | `set(int index, boolean element)` Replaces the element at the specified position in the receiver with the specified element.
`void` | `shuffleFromTo(int from, int to)` Randomly permutes the part of the receiver between `from` (inclusive) and `to` (inclusive).
`int` | `size()` Returns the number of elements contained in the receiver.
`AbstractBooleanList` | `times(int times)` Returns a list which is a concatenation of `times` times the receiver.
`ArrayList` | `toList()` Returns a `java.util.ArrayList` containing all the elements in the receiver.
`String` | `toString()` Returns a string representation of the receiver, containing the String representation of each element.

Methods inherited from class cern.colt.list.AbstractList
`addAllOf, beforeInsertAllOf, clear, mergeSort, mergeSortFromTo, quickSort, quickSortFromTo, remove, setSize, shuffle, sort, sortFromTo, trimToSize`

Methods inherited from class cern.colt.list.AbstractCollection
`isEmpty`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### add

    public void add(boolean element)

  Appends the specified element to the end of this list.

  Parameters:
    `element` - element to be appended to this list.

### addAllOfFromTo

    public void addAllOfFromTo(AbstractBooleanList other,
                               int from,
                               int to)

  Appends the part of the specified list between `from` (inclusive) and `to` (inclusive) to the receiver.

  Parameters:
    `other` - the list to be added to the receiver.
    `from` - the index of the first element to be appended (inclusive).
    `to` - the index of the last element to be appended (inclusive).
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`other.size()>0 && (from<0 || from>to || to>=other.size())`).

### beforeInsert

    public void beforeInsert(int index,
                             boolean element)

  Inserts the specified element before the specified position into the receiver. Shifts the element currently at that position (if any) and any subsequent elements to the right.

  Parameters:
    `index` - index before which the specified element is to be inserted (must be in [0,size]).
    `element` - element to be inserted.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`index < 0 || index > size()`).

### beforeInsertAllOfFromTo

    public void beforeInsertAllOfFromTo(int index,
                                        AbstractBooleanList other,
                                        int from,
                                        int to)

  Inserts the part of the specified list between `otherFrom` (inclusive) and `otherTo` (inclusive) before the specified position into the receiver. Shifts the element currently at that position (if any) and any subsequent elements to the right.

  Parameters:
    `index` - index before which to insert first element from the specified list (must be in [0,size])..
    `other` - list of which a part is to be inserted into the receiver.
    `from` - the index of the first element to be inserted (inclusive).
    `to` - the index of the last element to be inserted (inclusive).
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`other.size()>0 && (from<0 || from>to || to>=other.size())`).
    `IndexOutOfBoundsException` - index is out of range (`index < 0 || index > size()`).

### binarySearch

    public int binarySearch(boolean key)

  Searches the receiver for the specified value using the binary search algorithm. The receiver must must be sorted (as by the sort method) prior to making this call. If it is not sorted, the results are undefined: in particular, the call may enter an infinite loop. If the receiver contains multiple elements equal to the specified object, there is no guarantee which instance will be found.

  Parameters:
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the receiver; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the the point at which the value would be inserted into the receiver: the index of the first element greater than the key, or `receiver.size()`, if all elements in the receiver are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `Arrays`

### binarySearchFromTo

    public int binarySearchFromTo(boolean key,
                                  int from,
                                  int to)

  Searches the receiver for the specified value using the binary search algorithm. The receiver must must be sorted (as by the sort method) prior to making this call. If it is not sorted, the results are undefined: in particular, the call may enter an infinite loop. If the receiver contains multiple elements equal to the specified object, there is no guarantee which instance will be found.

  Parameters:
    `key` - the value to be searched for.
    `from` - the leftmost search position, inclusive.
    `to` - the rightmost search position, inclusive.
  Returns:
    index of the search key, if it is contained in the receiver; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the the point at which the value would be inserted into the receiver: the index of the first element greater than the key, or `receiver.size()`, if all elements in the receiver are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `Arrays`

### clone

    public Object clone()

  Returns a deep copy of the receiver.

  Overrides:
    `clone` in class `PersistentObject`
  Returns:
    a deep copy of the receiver.

### contains

    public boolean contains(boolean elem)

  Returns true if the receiver contains the specified element.

### delete

    public void delete(boolean element)

  Deletes the first element from the receiver that is identical to the specified element. Does nothing, if no such matching element is contained.

  Parameters:
    `element` - the element to be deleted.

### elements

    public boolean[] elements()

  Returns the elements currently stored, possibly including invalid elements between size and capacity. WARNING: For efficiency reasons and to keep memory usage low, this method may decide not to copy the array. So if subsequently you modify the returned array directly via the [] operator, be sure you know what you're doing.

  Returns:
    the elements currently stored.

### elements

    public AbstractBooleanList elements(boolean[] elements)

  Sets the receiver's elements to be the specified array. The size and capacity of the list is the length of the array. WARNING: For efficiency reasons and to keep memory usage low, this method may decide not to copy the array. So if subsequently you modify the returned array directly via the [] operator, be sure you know what you're doing.

  Parameters:
    `elements` - the new elements to be stored.
  Returns:
    the receiver itself.

### ensureCapacity

    public abstract void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of elements without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  Parameters:
    `minCapacity` - the desired minimum capacity.

### equals

    public boolean equals(Object otherObj)

  Compares the specified Object with the receiver. Returns true if and only if the specified Object is also an ArrayList of the same type, both Lists have the same size, and all corresponding pairs of elements in the two Lists are identical. In other words, two Lists are defined to be equal if they contain the same elements in the same order.

  Parameters:
    `otherObj` - the Object to be compared for equality with the receiver.
  Returns:
    true if the specified Object is equal to the receiver.

### fillFromToWith

    public void fillFromToWith(int from,
                               int to,
                               boolean val)

  Sets the specified range of elements in the specified array to the specified value.

  Parameters:
    `from` - the index of the first element (inclusive) to be filled with the specified value.
    `to` - the index of the last element (inclusive) to be filled with the specified value.
    `val` - the value to be stored in the specified elements of the receiver.

### forEach

    public boolean forEach(BooleanProcedure procedure)

  Applies a procedure to each element of the receiver, if any. Starts at index 0, moving rightwards.

  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all elements where iterated over, `true` otherwise.

### get

    public boolean get(int index)

  Returns the element at the specified position in the receiver.

  Parameters:
    `index` - index of element to return.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).

### indexOf

    public int indexOf(boolean element)

  Returns the index of the first occurrence of the specified element. Returns `-1` if the receiver does not contain this element.

  Parameters:
    `element` - the element to be searched for.
  Returns:
    the index of the first occurrence of the element in the receiver; returns `-1` if the element is not found.

### indexOfFromTo

    public int indexOfFromTo(boolean element,
                             int from,
                             int to)

  Returns the index of the first occurrence of the specified element. Returns `-1` if the receiver does not contain this element. Searches between `from`, inclusive and `to`, inclusive. Tests for identity.

  Parameters:
    `element` - element to search for.
    `from` - the leftmost search position, inclusive.
    `to` - the rightmost search position, inclusive.
  Returns:
    the index of the first occurrence of the element in the receiver; returns `-1` if the element is not found.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

### lastIndexOf

    public int lastIndexOf(boolean element)

  Returns the index of the last occurrence of the specified element. Returns `-1` if the receiver does not contain this element.

  Parameters:
    `element` - the element to be searched for.
  Returns:
    the index of the last occurrence of the element in the receiver; returns `-1` if the element is not found.

### lastIndexOfFromTo

    public int lastIndexOfFromTo(boolean element,
                                 int from,
                                 int to)

  Returns the index of the last occurrence of the specified element. Returns `-1` if the receiver does not contain this element. Searches beginning at `to`, inclusive until `from`, inclusive. Tests for identity.

  Parameters:
    `element` - element to search for.
    `from` - the leftmost search position, inclusive.
    `to` - the rightmost search position, inclusive.
  Returns:
    the index of the last occurrence of the element in the receiver; returns `-1` if the element is not found.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

### partFromTo

    public AbstractBooleanList partFromTo(int from,
                                          int to)

  Returns a new list of the part of the receiver between `from`, inclusive, and `to`, inclusive.

  Parameters:
    `from` - the index of the first element (inclusive).
    `to` - the index of the last element (inclusive).
  Returns:
    a new list
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

### removeAll

    public boolean removeAll(AbstractBooleanList other)

  Removes from the receiver all elements that are contained in the specified list. Tests for identity.

  Parameters:
    `other` - the other list.
  Returns:
    `true` if the receiver changed as a result of the call.

### removeFromTo

    public void removeFromTo(int from,
                             int to)

  Removes from the receiver all elements whose index is between `from`, inclusive and `to`, inclusive. Shifts any succeeding elements to the left (reduces their index). This call booleanens the list by `(to - from + 1)` elements.

  Specified by:
    `removeFromTo` in class `AbstractList`
  Parameters:
    `from` - index of first element to be removed.
    `to` - index of last element to be removed.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

### replaceFromToWithFrom

    public void replaceFromToWithFrom(int from,
                                      int to,
                                      AbstractBooleanList other,
                                      int otherFrom)

  Replaces a number of elements in the receiver with the same number of elements of another list. Replaces elements in the receiver, between `from` (inclusive) and `to` (inclusive), with elements of `other`, starting from `otherFrom` (inclusive).

  Parameters:
    `from` - the position of the first element to be replaced in the receiver
    `to` - the position of the last element to be replaced in the receiver
    `other` - list holding elements to be copied into the receiver.
    `otherFrom` - position of first element within other list to be copied.

### replaceFromToWithFromTo

    public void replaceFromToWithFromTo(int from,
                                        int to,
                                        AbstractBooleanList other,
                                        int otherFrom,
                                        int otherTo)

  Replaces the part between `from` (inclusive) and `to` (inclusive) with the other list's part between `otherFrom` and `otherTo`. Powerful (and tricky) method! Both parts need not be of the same size (part A can both be smaller or larger than part B). Parts may overlap. Receiver and other list may (but most not) be identical. If `from > to`, then inserts other part before `from`.

  Parameters:
    `from` - the first element of the receiver (inclusive)
    `to` - the last element of the receiver (inclusive)
    `other` - the other list (may be identical with receiver)
    `otherFrom` - the first element of the other list (inclusive)
    `otherTo` - the last element of the other list (inclusive)

    Examples:

         a=[0, 1, 2, 3, 4, 5, 6, 7]
         b=[50, 60, 70, 80, 90]
         a.R(...)=a.replaceFromToWithFromTo(...)

         a.R(3,5,b,0,4)-->[0, 1, 2, 50, 60, 70, 80, 90, 6, 7]
         a.R(1,6,b,0,4)-->[0, 50, 60, 70, 80, 90, 7]
         a.R(0,6,b,0,4)-->[50, 60, 70, 80, 90, 7]
         a.R(3,5,b,1,2)-->[0, 1, 2, 60, 70, 6, 7]
         a.R(1,6,b,1,2)-->[0, 60, 70, 7]
         a.R(0,6,b,1,2)-->[60, 70, 7]
         a.R(5,3,b,0,4)-->[0, 1, 2, 3, 4, 50, 60, 70, 80, 90, 5, 6, 7]
         a.R(5,0,b,0,4)-->[0, 1, 2, 3, 4, 50, 60, 70, 80, 90, 5, 6, 7]
         a.R(5,3,b,1,2)-->[0, 1, 2, 3, 4, 60, 70, 5, 6, 7]
         a.R(5,0,b,1,2)-->[0, 1, 2, 3, 4, 60, 70, 5, 6, 7]

         Extreme cases:
         a.R(5,3,b,0,0)-->[0, 1, 2, 3, 4, 50, 5, 6, 7]
         a.R(5,3,b,4,4)-->[0, 1, 2, 3, 4, 90, 5, 6, 7]
         a.R(3,5,a,0,1)-->[0, 1, 2, 0, 1, 6, 7]
         a.R(3,5,a,3,5)-->[0, 1, 2, 3, 4, 5, 6, 7]
         a.R(3,5,a,4,4)-->[0, 1, 2, 4, 6, 7]
         a.R(5,3,a,0,4)-->[0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 5, 6, 7]
         a.R(0,-1,b,0,4)-->[50, 60, 70, 80, 90, 0, 1, 2, 3, 4, 5, 6, 7]
         a.R(0,-1,a,0,4)-->[0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 5, 6, 7]
         a.R(8,0,a,0,4)-->[0, 1, 2, 3, 4, 5, 6, 7, 0, 1, 2, 3, 4]

### replaceFromWith

    public void replaceFromWith(int from,
                                Collection other)

  Replaces the part of the receiver starting at `from` (inclusive) with all the elements of the specified collection. Does not alter the size of the receiver. Replaces exactly `Math.max(0,Math.min(size()-from, other.size()))` elements.

  Specified by:
    `replaceFromWith` in class `AbstractList`
  Parameters:
    `from` - the index at which to copy the first element from the specified collection.
    `other` - Collection to replace part of the receiver
  Throws:
    `IndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).

### retainAll

    public boolean retainAll(AbstractBooleanList other)

  Retains (keeps) only the elements in the receiver that are contained in the specified other list. In other words, removes from the receiver all of its elements that are not contained in the specified other list.

  Parameters:
    `other` - the other list to test against.
  Returns:
    `true` if the receiver changed as a result of the call.

### reverse

    public void reverse()

  Reverses the elements of the receiver. Last becomes first, second last becomes second first, and so on.

  Specified by:
    `reverse` in class `AbstractList`

### set

    public void set(int index,
                    boolean element)

  Replaces the element at the specified position in the receiver with the specified element.

  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Throws:
    `IndexOutOfBoundsException` - if `index < 0 || index >= size()`.

### shuffleFromTo

    public void shuffleFromTo(int from,
                              int to)

  Randomly permutes the part of the receiver between `from` (inclusive) and `to` (inclusive).

  Specified by:
    `shuffleFromTo` in class `AbstractList`
  Parameters:
    `from` - the index of the first element (inclusive) to be permuted.
    `to` - the index of the last element (inclusive) to be permuted.
  Throws:
    `IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

### size

    public int size()

  Returns the number of elements contained in the receiver.

  Specified by:
    `size` in class `AbstractCollection`

### times

    public AbstractBooleanList times(int times)

  Returns a list which is a concatenation of `times` times the receiver.

  Parameters:
    `times` - the number of times the receiver shall be copied.

### toList

    public ArrayList toList()

  Returns a `java.util.ArrayList` containing all the elements in the receiver.

  Specified by:
    `toList` in class `AbstractCollection`

### toString

    public String toString()

  Returns a string representation of the receiver, containing the String representation of each element.

  Overrides:
    `toString` in class `AbstractCollection`

Colt 1.2.0

Jump to the Colt Homepage